# Adding a Packaging Stage

This tutorial guides you through enhancing your GitLab CI/CD pipeline by adding a workflow keyword and a packaging stage. By the end of this tutorial, you'll have a pipeline configured to dynamically set package versions based on the commit type (tags, branches) and to package your application.

[TOC]

## Prerequisites

- A GitLab account and a project.
- Basic understanding of GitLab CI/CD.
- Familiarity with YAML syntax.

## Pipeline Configuration

Your `.gitlab-ci.yml` file defines your CI/CD pipeline. We'll add a packaging stage to your pipeline: `package`. Additionally, we'll utilize the `workflow` keyword to dynamically define the package version. This allows us to name the final package according to version and architecture if we so desire.

### Variables

First, define the variables that will be used across multiple stages:

```yaml
variables:
  PROJECT_IMAGE: gitlab.home.arpa:5050/developer/workshop/project-image:latest
  GITLAB_CLI_IMAGE: gitlab.home.arpa:5050/developer/workshop/gitlab-release-cli:latest
  PROJECT_API: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}
  PACKAGE_ARCH: generic # we will change this in a later lesson to work with multi-architecture builds
  PACKAGE_NAME: ${CI_PROJECT_NAME}-${PACKAGE_VERSION}-${PACKAGE_ARCH}
```

### Workflow Keyword
The workflow keyword allows you to control when the pipeline is triggered and sets the package version dynamically:

```yaml
workflow:
  rules:
    - if: $CI_COMMIT_TAG
      variables:
        PACKAGE_VERSION: "${CI_COMMIT_TAG}"
    - if: ($CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH)
      variables:
        PACKAGE_VERSION: "${CI_COMMIT_BRANCH}_${CI_COMMIT_SHORT_SHA}"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      variables:
        PACKAGE_VERSION: "latest"
```

- **Tagged Commits:** When a commit is tagged, the pipeline uses the tag name as the PACKAGE_VERSION. This is ideal for release versions.
- **Non-default Branches:** For commits on branches other than the default branch, without tags, the version combines the branch name and the short commit SHA. This approach is useful for pre-release or development versions.
- **Default Branch Commits:** For commits on the default branch, the pipeline sets the version to "latest". This is typically used for continuous integration builds.
This setup ensures your pipeline behavior adapts based on the commit context, facilitating a more streamlined development and release process.

### Package Stage
The package stage is where your application is bundled for distribution. This stage compiles your code, generates a package, and prepares it for deployment. Let's dive into the details:

```yaml
package:
  image: $PROJECT_IMAGE
  stage: package
  script:
    - cd build
    - cpack
    # This command packages your application, leveraging CMake's packaging system.
    - cp out/${PACKAGE_NAME}.tar.gz ..
    # Copies the packaged application to the project root directory for easy access.
  dependencies:
    - build
    - test
    # Ensures this stage runs after 'build' and 'test' stages.
  artifacts:
    paths:
      - ${PACKAGE_NAME}.tar.gz
      # Specifies the artifact generated by this job, making it available for future stages or for download.
    expire_in: 1 week
    # Sets the artifact's expiry time to 1 week, after which it's automatically deleted.
```

In this stage:

- We switch to the build directory where our compiled code resides.
cpack is invoked to generate a package. This tool is part of CMake and facilitates the packaging of the software.
- The packaged application, named according to our predefined variables, is then moved to a more accessible location, ensuring it's easy to find and deploy.
- The dependencies keyword ensures that this stage only runs after successful completion of the build and test stages, maintaining the logical order of operations.
- Finally, the generated package is marked as an artifact, which can be stored temporarily in GitLab for easy access or deployment.

### Full Example
Your `.gitlab-ci.yml` should now look like the following:

```yaml
---
variables:
  PROJECT_IMAGE: gitlab.home.arpa:5050/developer/workshop/project-image:latest
  GITLAB_CLI_IMAGE: gitlab.home.arpa:5050/developer/workshop/gitlab-release-cli:latest
  PROJECT_API: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}
  PACKAGE_ARCH: generic
  PACKAGE_NAME: ${CI_PROJECT_NAME}-${PACKAGE_VERSION}-${PACKAGE_ARCH}

stages:
  - lint
  - build
  - analysis
  - test
  - package

workflow:
  rules:
    - if: $CI_COMMIT_TAG
      variables:
        PACKAGE_VERSION: "${CI_COMMIT_TAG}"
    - if: ($CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH)
      variables:
        PACKAGE_VERSION: "${CI_COMMIT_BRANCH}_${CI_COMMIT_SHORT_SHA}"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      variables:
        PACKAGE_VERSION: "latest"

lint:
  image: $PROJECT_IMAGE
  stage: lint
  script:
    - find . -iname '*.c' -o -iname '*.h' | xargs clang-format -i --style=microsoft
    - git diff --exit-code || (echo "Code style issues found. Please run 'clang-format' locally." && exit 1)

build:
  image: $PROJECT_IMAGE
  stage: build
  script:
    - cmake -DPACKAGE_NAME=${CI_PROJECT_NAME} -DPACKAGE_VERSION=${PACKAGE_VERSION} -DPACKAGE_ARCH=${PACKAGE_ARCH} -S . -B build --preset default
    - cmake --build build
  artifacts:
    paths:
      - build/
    expire_in: 1 week

analysis:
  image: $PROJECT_IMAGE
  stage: analysis
  script:
    - find . -iname '*.c' -o -iname '*.h' | xargs clang-tidy -p build --checks=*,-clang-analyzer-alpha.*

test:
  image: $PROJECT_IMAGE
  stage: test
  script:
    - ./build/main > output.txt
    - cat output.txt
    - |
      if grep -q "Hello, GitLab CI/CD!" output.txt; then
        echo "Test Passed" > results.txt
      else
        echo "Test Failed" > results.txt
        exit 1
      fi
  artifacts:
    paths:
      - results.txt
    expire_in: 1 week

package:
  image: $PROJECT_IMAGE
  stage: package
  script:
    - cd build
    - cpack
    - cp out/${PACKAGE_NAME}.tar.gz ..
  dependencies:
    - build
    - test
  artifacts:
    paths:
      - ${PACKAGE_NAME}.tar.gz
```

## Conclusion
By focusing on the package stage, you've created a streamlined process for packaging your application within the GitLab CI/CD pipeline. This setup not only automates your build and release process but also ensures that every package is versioned and traceable, aligning with best practices for software development and deployment.

[Overview](../../README.md) | [Back](./05_workflow_and_rules.md) | [Next](./07_adding_release_stage.md)
